#include "SDK.h"
#include "Panels.h"
#include "CDrawManager.h"
#include "Util.h"
#include "ESP.h"
#include "Menu.h"
#include "CDraw.h"
#include "Styles.h"
#include "Other.h"
#include "CMat.h"
#include "Radar.h"
CScreenSize gScreenSize;
void __fastcall Hooked_PaintTraverse( PVOID pPanels, int edx, unsigned int vguiPanel, bool forceRepaint, bool allowForce)
{
	try
	{
		CBaseEntity* pLocal = gInts.EntList->GetClientEntity(me);
		auto crosshair = gInts.cvar->FindVar("crosshair");
		if (!strcmp("HudScope", gInts.Panels->GetName(vguiPanel)) && eESP.noscope.value)
		{
				if (pLocal->GetCond() & tf_cond::TFCond_Zoomed)
				{
					crosshair->SetValue(0);
				}
				else
				{
					crosshair->SetValue(1);
				}

			return;
		}
		VMTManager& hook = VMTManager::GetHook(pPanels); 
		hook.GetMethod<void(__thiscall*)(PVOID, unsigned int, bool, bool)>(gOffsets.iPaintTraverseOffset)(pPanels, vguiPanel, forceRepaint, allowForce);   
		static unsigned int vguiFocusOverlayPanel;
		WindowStyle* style = new DefaultStyle();

		if (vguiFocusOverlayPanel == NULL)
		{											
			const char* szName = gInts.Panels->GetName(vguiPanel);
			if( szName[0] == 'F' && szName[5] == 'O' &&  szName[12] == 'P' )
			{
				vguiFocusOverlayPanel = vguiPanel;
				Intro();
			}
		}

		if (vguiFocusOverlayPanel == vguiPanel )      
		{
			if (eOther.cscreenshots.value && gInts.Engine->IsTakingScreenshot() || eOther.cscreenshots.value && GetAsyncKeyState(VK_F12) || eOther.cscreenshots.value && GetAsyncKeyState(VK_SNAPSHOT))
			    return;

			gInts.Panels->SetTopmostPopup(vguiFocusOverlayPanel, true);

			CScreenSize newSize;
			gInts.Engine->GetScreenSize(newSize.iScreenWidth, newSize.iScreenWidth);
			if (newSize.iScreenWidth != gScreenSize.iScreenWidth || newSize.iScreenHeight != gScreenSize.iScreenHeight)
				eDraw.Reload();
			eMenu.GetInput();
			eMenu.Draw();
			gInts.Panels->SetMouseInputEnabled(vguiPanel, eMenu.enabled);
			eMenu.EndInput();


			if (eOther.purebypass.value || eESP.player_enabled.value)
			{
				bool check = false;
				if (!gInts.Engine->IsInGame() && check == false)
				{
						void** pure_addr = nullptr;
						if (!pure_addr)
						{
							pure_addr = *reinterpret_cast<void***>(gSignatures.GetEngineSignature("A1 ? ? ? ? 56 33 F6 85 C0") + 1);
						} *
							pure_addr = (void*)0;

						check = true;
				}
			}

			int iWidth, iHeight;        
			gInts.Engine->GetScreenSize(iWidth, iHeight);
			if (gScreenSize.iScreenWidth != iWidth || gScreenSize.iScreenHeight != iHeight)
				gInts.Engine->GetScreenSize(gScreenSize.iScreenWidth, gScreenSize.iScreenHeight);

			if (!pLocal)
				return;

			gRadar.DrawRadarBack();
			eESP.Start(pLocal);



			if (gInts.Engine->IsInGame() && gInts.Engine->IsConnected())
			{
			   if (!eESP.noscope.value)
			     return;

				if (pLocal->GetLifeState() == LIFE_ALIVE && pLocal->GetCond() & tf_cond::TFCond_Zoomed)
				{
					int width, height;
					gInts.Engine->GetScreenSize(width, height);
					gDrawManager.DrawLine(width / 2, 0, width / 2, height, Color(0, 0, 0, 255));
					gDrawManager.DrawLine(0, height / 2, width, height / 2, Color(0, 0, 0, 255));
				}

			}
		}
	}
	catch(...)
	{

	}
}
void Intro( void )
{
	try
	{
		gDrawManager.Initialize();    
		eDraw.Init();
		gMat.Initialize();
		InitTextures();
		gNetVars.Initialize();
		eMenu.CreateGUI();
	}
	catch(...)
	{
	}
}
