#pragma once

class WindowStyle
{
public:
	virtual void Dialog(int x, int y, int w, int h) = 0;
	virtual int ControlPanel(int x, int y, int w, int h, const char* name = 0) = 0;
	virtual int DialogButton(int x, int y, int w, const char* text = 0, bool mouseOver = false) = 0;
	virtual int TopBar(int x, int y, int w, const char* title = 0) = 0;
};

class DefaultStyle : public WindowStyle
{
public:
	void Dialog(int x, int y, int w, int h);
	int ControlPanel(int x, int y, int w, int h, const char* name = 0);
	int DialogButton(int x, int y, int w, const char* text, bool mouseOver = false);
	int TopBar(int x, int y, int w, const char* title = 0);
};